/*@lineinfo:filename=ServletExample*//*@lineinfo:user-code*//*@lineinfo:1^1*//*
   ServletExample.sqlj illustrates how to include
   SQLJ statements in a servlet.
*/

// import the servlet, io, and util classes
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

// import the SQLJ classes
import java.sql.*;
import oracle.sqlj.runtime.Oracle;
import sqlj.runtime.ref.DefaultContext;

public class ServletExample extends HttpServlet {

  // declare an iterator class
  /*@lineinfo:generated-code*//*@lineinfo:20^3*/

//  ************************************************************
//  SQLJ iterator declaration:
//  ************************************************************

private static class CustIteratorClass 
extends sqlj.runtime.ref.ResultSetIterImpl
implements sqlj.runtime.NamedIterator
{
  public CustIteratorClass(sqlj.runtime.profile.RTResultSet resultSet) 
    throws java.sql.SQLException 
  {
    super(resultSet);
    idNdx = findColumn("id");
    first_nameNdx = findColumn("first_name");
    last_nameNdx = findColumn("last_name");
    dobNdx = findColumn("dob");
    phoneNdx = findColumn("phone");
  }
  public int id() 
    throws java.sql.SQLException 
  {
    return resultSet.getIntNoNull(idNdx);
  }
  private int idNdx;
  public String first_name() 
    throws java.sql.SQLException 
  {
    return resultSet.getString(first_nameNdx);
  }
  private int first_nameNdx;
  public String last_name() 
    throws java.sql.SQLException 
  {
    return resultSet.getString(last_nameNdx);
  }
  private int last_nameNdx;
  public java.sql.Date dob() 
    throws java.sql.SQLException 
  {
    return resultSet.getDate(dobNdx);
  }
  private int dobNdx;
  public String phone() 
    throws java.sql.SQLException 
  {
    return resultSet.getString(phoneNdx);
  }
  private int phoneNdx;
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:26^3*/

  // handle get request
  public void doGet(
    HttpServletRequest req,
    HttpServletResponse res
  ) throws ServletException, IOException {

    // output HTML
    res.setContentType("text/html");
    PrintWriter out = res.getWriter();
    out.println("<html><head><title>Customers</title></head>");
    out.println("<body>");

    // retrieve and display the customer details
    try {

      DefaultContext conn_context = Oracle.connect(
        "jdbc:oracle:thin:@localhost:1521:orcl",
        "fundamental_user",
        "fundamental_password"
      );

      CustIteratorClass cust_iterator;

      /*@lineinfo:generated-code*//*@lineinfo:51^7*/

//  ************************************************************
//  #sql [conn_context] cust_iterator = { SELECT
//            id, first_name, last_name, dob, phone
//          FROM
//            customers
//         };
//  ************************************************************

{
  sqlj.runtime.ConnectionContext __sJT_connCtx = conn_context;
  if (__sJT_connCtx == null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext __sJT_execCtx = __sJT_connCtx.getExecutionContext();
  if (__sJT_execCtx == null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_EXEC_CTX();
  synchronized (__sJT_execCtx) {
    sqlj.runtime.profile.RTStatement __sJT_stmt = __sJT_execCtx.registerStatement(__sJT_connCtx, ServletExample_SJProfileKeys.getKey(0), 0);
    try 
    {
      sqlj.runtime.profile.RTResultSet __sJT_result = __sJT_execCtx.executeQuery();
      cust_iterator = new CustIteratorClass(__sJT_result);
    }
    finally 
    {
      __sJT_execCtx.releaseStatement();
    }
  }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:56^7*/

      // write the customer details out to an HTML table
      out.println("<table width=100% border=1>");
      out.println("<tr>");
      out.println("<th>Id</th>");
      out.println("<th>First Name</th>");
      out.println("<th>Last Name</th>");
      out.println("<th>DOB</th>");
      out.println("<th>Phone</th>");
      out.println("</tr>");

      while (cust_iterator.next()) {

        out.println("<tr>");
        out.println("<td>" + cust_iterator.id() + "</td>");
        out.println("<td>" + cust_iterator.first_name() + "</td>");
        out.println("<td>" + cust_iterator.last_name() + "</td>");
        out.println("<td>" + cust_iterator.dob() + "</td>");
        out.println("<td>" + cust_iterator.phone() + "</td>");
        out.println("</tr>");

      } // end of while

      cust_iterator.close();
      conn_context.close();

      out.println("</table>");
      out.println("</body></html>");

    } catch ( SQLException e ) {

      out.println("SQLException " + e);

    }
  }
}/*@lineinfo:generated-code*/class ServletExample_SJProfileKeys 
{
  private static ServletExample_SJProfileKeys inst = null;
  public static java.lang.Object getKey(int keyNum) 
    throws java.sql.SQLException 
  {
    if (inst == null)
    {
      inst = new ServletExample_SJProfileKeys();
    }
    return inst.keys[keyNum];
  }
  private final sqlj.runtime.profile.Loader loader = sqlj.runtime.RuntimeContext.getRuntime().getLoaderForClass(getClass());
  private java.lang.Object[] keys;
  private ServletExample_SJProfileKeys() 
    throws java.sql.SQLException 
  {
    keys = new java.lang.Object[1];
    keys[0] = DefaultContext.getProfileKey(loader, "ServletExample_SJProfile0");
  }
}
