/*@lineinfo:filename=Sqlj9iDynamicExample1*//*@lineinfo:user-code*//*@lineinfo:1^1*//*
   The program Sqlj9iDynamicExample1.sqlj illustrates how to embed
   dynamic SQL statements directly in a SQLJ program.
*/

// import required packages
import java.sql.*;
import oracle.sqlj.runtime.Oracle;

public class Sqlj9iDynamicExample1 {

  public static void main(String [] args) {

    try {

      Oracle.connect(
        "jdbc:oracle:thin:@localhost:1521:orcl",
        "fundamental_user",
        "fundamental_password"
      );

      int id = 1;
      String first_name = null;
      String last_name = null;
      String phone = null;

      String table = "customers";
      String query = "id = " + id;
      String column = "first_name";

      /*@lineinfo:generated-code*//*@lineinfo:31^7*/

//  ************************************************************
//  #sql { SELECT
//            :column, last_name, phone
//          
//          FROM
//            :table
//          WHERE
//            :query
//         };
//  ************************************************************

{
  sqlj.runtime.profile.RTResultSet __sJT_rtRs;
  sqlj.runtime.ConnectionContext __sJT_connCtx = sqlj.runtime.ref.DefaultContext.getDefaultContext();
  if (__sJT_connCtx == null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext __sJT_execCtx = __sJT_connCtx.getExecutionContext();
  if (__sJT_execCtx == null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_EXEC_CTX();
  String __sJT_1 = column;
  String __sJT_2 = table;
  String __sJT_3 = query;
  synchronized (__sJT_execCtx) {
    sqlj.runtime.profile.RTStatement __sJT_stmt = __sJT_execCtx.registerStatement(__sJT_connCtx, Sqlj9iDynamicExample1_SJProfileKeys.getKey(0), 0);
    try 
    {
      __sJT_stmt.setString(1, __sJT_1);
      __sJT_stmt.setString(2, __sJT_2);
      __sJT_stmt.setString(3, __sJT_3);
      sqlj.runtime.profile.RTResultSet __sJT_result = __sJT_execCtx.executeQuery();
      __sJT_rtRs = __sJT_result;
    }
    finally 
    {
      __sJT_execCtx.releaseStatement();
    }
  }
  try 
  {
    sqlj.runtime.ref.ResultSetIterImpl.checkColumns(__sJT_rtRs, 3);
    if (!__sJT_rtRs.next())
    {
      sqlj.runtime.error.RuntimeRefErrors.raise_NO_ROW_SELECT_INTO();
    }
    first_name = __sJT_rtRs.getString(1);
    last_name = __sJT_rtRs.getString(2);
    phone = __sJT_rtRs.getString(3);
    if (__sJT_rtRs.next())
    {
      sqlj.runtime.error.RuntimeRefErrors.raise_MULTI_ROW_SELECT_INTO();
    }
  }
  finally 
  {
    __sJT_rtRs.close();
  }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:40^7*/

      System.out.println("Details for customer " + id + ":");
      System.out.println(column + " = " + first_name);
      System.out.println("last_name = " + last_name);
      System.out.println("phone = " + phone);

      Oracle.close();

    } catch (SQLException e) {

      System.err.println("SQLException " + e);
      System.exit(1);

    }

  } // end of main()

}/*@lineinfo:generated-code*/class Sqlj9iDynamicExample1_SJProfileKeys 
{
  private static Sqlj9iDynamicExample1_SJProfileKeys inst = null;
  public static java.lang.Object getKey(int keyNum) 
    throws java.sql.SQLException 
  {
    if (inst == null)
    {
      inst = new Sqlj9iDynamicExample1_SJProfileKeys();
    }
    return inst.keys[keyNum];
  }
  private final sqlj.runtime.profile.Loader loader = sqlj.runtime.RuntimeContext.getRuntime().getLoaderForClass(getClass());
  private java.lang.Object[] keys;
  private Sqlj9iDynamicExample1_SJProfileKeys() 
    throws java.sql.SQLException 
  {
    keys = new java.lang.Object[1];
    keys[0] = sqlj.runtime.ref.DefaultContext.getProfileKey(loader, "Sqlj9iDynamicExample1_SJProfile0");
  }
}
