/*@lineinfo:filename=CustomerBean*//*@lineinfo:user-code*//*@lineinfo:1^1*//*
   CustomerBean.sqlj is the bean class for the customer bean.
   This file contains the implementation of the methods
   defined in the remote interface.
*/

package customer;

import customer.CustomerRecord;

import java.sql.*;
import java.rmi.RemoteException;
import javax.ejb.*;

// CustomerBean is a session bean
public class CustomerBean implements SessionBean {

  public void ejbCreate() throws CreateException, RemoteException {}
  public void ejbActivate() {}
  public void ejbPassivate() {}
  public void ejbRemove() {}
  public void setSessionContext(SessionContext ctx) {}

  // getRow() retrieves the specified row from the customers table
  // and returns the row in the form of a CustomerRecord object
  public CustomerRecord getRow(

    int id

  ) throws SQLException, RemoteException
  {

    String first_name;
    String last_name;
    Date dob;
    String phone;

    // retrieve the row using SQLJ
    /*@lineinfo:generated-code*//*@lineinfo:39^5*/

//  ************************************************************
//  #sql { SELECT
//          first_name, last_name, dob, phone
//        
//        FROM
//          customers
//        WHERE
//          id = :id
//       };
//  ************************************************************

{
  sqlj.runtime.profile.RTResultSet __sJT_rtRs;
  sqlj.runtime.ConnectionContext __sJT_connCtx = sqlj.runtime.ref.DefaultContext.getDefaultContext();
  if (__sJT_connCtx == null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext __sJT_execCtx = __sJT_connCtx.getExecutionContext();
  if (__sJT_execCtx == null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_EXEC_CTX();
  int __sJT_1 = id;
  synchronized (__sJT_execCtx) {
    sqlj.runtime.profile.RTStatement __sJT_stmt = __sJT_execCtx.registerStatement(__sJT_connCtx, CustomerBean_SJProfileKeys.getKey(0), 0);
    try 
    {
      __sJT_stmt.setInt(1, __sJT_1);
      sqlj.runtime.profile.RTResultSet __sJT_result = __sJT_execCtx.executeQuery();
      __sJT_rtRs = __sJT_result;
    }
    finally 
    {
      __sJT_execCtx.releaseStatement();
    }
  }
  try 
  {
    sqlj.runtime.ref.ResultSetIterImpl.checkColumns(__sJT_rtRs, 4);
    if (!__sJT_rtRs.next())
    {
      sqlj.runtime.error.RuntimeRefErrors.raise_NO_ROW_SELECT_INTO();
    }
    first_name = __sJT_rtRs.getString(1);
    last_name = __sJT_rtRs.getString(2);
    dob = __sJT_rtRs.getDate(3);
    phone = __sJT_rtRs.getString(4);
    if (__sJT_rtRs.next())
    {
      sqlj.runtime.error.RuntimeRefErrors.raise_MULTI_ROW_SELECT_INTO();
    }
  }
  finally 
  {
    __sJT_rtRs.close();
  }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:48^5*/

    // create and return a CustomerRecord object that contains
    // the column values for the row
    return new CustomerRecord(id, first_name, last_name, dob, phone);
  }
}/*@lineinfo:generated-code*/class CustomerBean_SJProfileKeys 
{
  private static CustomerBean_SJProfileKeys inst = null;
  public static java.lang.Object getKey(int keyNum) 
    throws java.sql.SQLException 
  {
    if (inst == null)
    {
      inst = new CustomerBean_SJProfileKeys();
    }
    return inst.keys[keyNum];
  }
  private final sqlj.runtime.profile.Loader loader = sqlj.runtime.RuntimeContext.getRuntime().getLoaderForClass(getClass());
  private java.lang.Object[] keys;
  private CustomerBean_SJProfileKeys() 
    throws java.sql.SQLException 
  {
    keys = new java.lang.Object[1];
    keys[0] = sqlj.runtime.ref.DefaultContext.getProfileKey(loader, "customer.CustomerBean_SJProfile0");
  }
}
